/* Wake AESSYS up at regular intervals */

#include <signal.h>
#include <mintbind.h>
#include <gem.h>

#define MYNAME "  WakeGEM Daemon"	/* user visible name */
#define INTERVAL 3000			/* milliseconds */

short aespid;
volatile short quit = 0;

static void alarm()
{
	(void)Pkill(aespid,SIGCONT);
}

static void term()
{
	quit = 1;
}

int main()
{
	register short apid = appl_init(), tmp;

	if (apid < 0)
		return -1;

	(void)Pnice(20);
	if ((tmp = appl_find("AESSYS  ")) > -1) {
		aespid = appl_find((void *)(0xfffe0000|tmp));
		if (aespid > 0) {
			menu_register(apid,MYNAME);

			Psigsetmask(0x00000003L);
			Psignal(SIGINT, &term);
			Psignal(SIGQUIT, &term);
			Psignal(SIGTERM, &term);
			Psignal(SIGALRM, &alarm);

			while(!quit) {
				Tmalarm(INTERVAL);
				Pause();
			}
		}
	}

	appl_exit();
	return 0;
}
